<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_message_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnMessageType".
 *
 * Columns in table "cpn_message_type" available as properties of the model,
 * followed by relations of table "cpn_message_type" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 *
 * @property CpnCommunicationQueue[] $cpnCommunicationQueues
 * @property CpnEhrCommunicationQueue[] $cpnEhrCommunicationQueues
 */
abstract class BaseCpnMessageType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_message_type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnMessageType|CpnMessageTypes', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('name', 'length', 'max' => 100),
            array('id, name', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnCommunicationQueues' => array(self::HAS_MANY, 'CpnCommunicationQueue', 'cpn_message_type_id'),
            'cpnEhrCommunicationQueues' => array(self::HAS_MANY, 'CpnEhrCommunicationQueue', 'cpn_message_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'cpnCommunicationQueues' => null,
            'cpnEhrCommunicationQueues' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
